# coding: UTF-8
#nvdajptext/Wakach.py
#A part of NonVisual Desktop Access (NVDA)
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.
#Copyright (C) 2010-2011 Masataka.Shinke, Takuya Nishimoto
# Usage for Test:
# > python nvdajptext\Wakach.py

_logwrite = None

from mecab import *

try:
	from logHandler import log
	_logwrite = log.info
except:
	def __print(s): print s
	_logwrite = __print

def Mecab_split(feature, size):
	if feature is None or size is None: 
		return
	s2 = ''
	for i in xrange(0, size):
		s = string_at(feature[i])
		if s:
			try:
				sp=u'空白'
				sp1=sp.encode(CODE)

				sp=u'数'
				sp2=sp.encode(CODE)

				sp=u'記号'
				sp3=sp.encode(CODE)

				rr=s.split(",")[1]
				ss=s.split(",")[2]

				# 空白の場合
				if(ss==sp1):
					s2 += ' '
				# 数値の場合
				elif(ss==sp2):
					aa=unicode(s.split(",")[0],CODE)
					bb=unicodedata.normalize('NFKC',aa)
					if(aa==bb):
						s2 += s.split(",")[9]
						s2 += ' '
					else:
						s2 += s.split(",")[0]
				# 記号の場合    
				#elif(rr==sp3):
				#    aa=unicode(s.split(",")[0],"cp932")
				#    bb=unicodedata.normalize('NFKC',aa)
				#    if(aa==bb):
				#        s2 += s.split(",")[9]
				#        s2 += ' '
				#    else:
				#        s2 += s.split(",")[0]
				else:
					aa=unicode(s.split(",")[0],CODE)
					bb=unicodedata.normalize('NFKC',aa)
					if(aa==bb):
						s2 += s.split(",")[9]
						s2 += ' ' 
					else:
						s2 += s.split(",")[0]
			except:
				s2 += s.split(",")[0]
				s2 += ' ' 
	s = re.sub("  ", " ", unicodedata.normalize('NFKC',unicode(s2.strip(),CODE)) )
	s = re.sub(u" 。", u"。", s)
	s = re.sub(u" 、", u"、", s)
	return s

def initialize():
	global _logwrite
	Mecab_initialize(_logwrite)
	if _logwrite: _logwrite("Wakach initialize() done.")

def terminate():
	global _logwrite
	if _logwrite: _logwrite("Wakach terminate() done.")

def Mecab_wakach(msg1):
	msg=unicodedata.normalize('NFKC',msg1)
	Mecab_initialize(_logwrite)
	s = Mecab_text2mecab(msg)
	mf = MecabFeatures()
	Mecab_analysis(s, mf)
	#Mecab_print(feature, size,__print)
	s = Mecab_split(mf.feature, mf.size)
	mf = None
	return s

if __name__ == "__main__":
	print Mecab_wakach(u"ウィンドウをタスク バーに移動します。")
